c ** PGI compile: pgf77 CRU2RCM.f -L../../Commons/env/liblinux -lnetcdf
c ** IFC compile: ifc -tpp7 -O3 -cm -w -w90 -w95 CRU2RCM.f -L../../Commons/env/liblinux -lnetcdf -o cru
      PROGRAM RWDATA

      implicit none
      include 'domain.param'
      include 'cru.param'

      integer ny, nx
      PARAMETER (ny=iy-2,nx=jx-2)
 
      real xlon(ny,nx), xlat(ny,nx), xlonx(iy,jx), xlatx(iy,jx)
     &   , GRIDRCM(NY,NX), GRIDNC(nx,ny)
     &   , clatx, clonx, platx, plonx, dsx

      real gridlalo(NLON,NLAT), LONI(NLON), LATI(NLAT)

C ******    NetCDF Output Stuff
      real xlat1d(ny), xlon1d(nx), vmisdat, xmin
      INTEGER idim(3), idt0(4), idt1(4), idt2(4), ndim, ncid, julnc
     &      , idcdf, idcdfout, ncopn, ncdid, ncvid, ncnowrit
      integer*2 imisdat
      parameter (vmisdat =-32767.,xmin=-100., ndim=3)
      parameter(ncnowrit = 0)
      character lnam*20, units*13
      REAL vvarmin(3), vvarmax(3), sigf(2), scale, offset, sig1d(1)
      real*8 xhro

c ****** Other stuff
      real aaa, grdfac, ddeg
      character iprojx*6
      integer i, j, idot, nlo, nla, ierr, idatex0, idatex1, idatex2
     &      , idatex, imo, iyr, idy, ihr, idyr, idmo, itim
     &      , iyy, jxx, kzz

      print*,'INPUT FILE:',infile
      print*,'OUTPUT FILE:',outfile

C ******  SETUP LONGITUDES AND LATITUDES RCM GRID
      open (unit=10,file='fort.10',status='old',form='unformatted'
     &    ,recl=iy*jx*ibyte,access='direct')
      read (10,rec=1) iyy,jxx,kzz,dsx,clatx,clonx,platx,plonx
     &              , grdfac,iprojx
      if (iyy.ne.iy .or. jxx.ne.jx) then
        print*,'DOMAIN.INFO is inconsistent with domain.param'
        print*,'  domain.param:    iy=',iy,   '   jx=',jx
        print*,'  DOMAIN.INFO:     iy=',iyy,  '   jx=',jxx
        stop 780
      end if
      if (abs(ds*1000.-dsx).gt.0.01) then
        print*,'DOMAIN.INFO is inconsistent with domain.param'
        print*,'  domain.param: ds=',ds*1000.
        print*,'  DOMAIN.INFO:  ds=',dsx
        stop 781
      end if
      if (clatx.ne.clat .or. clonx.ne.clon .or.
     &    platx.ne.plat .or. plonx.ne.plon) then
        print*,'DOMAIN.INFO is inconsistent with domain.param'
        print*,'  domain.param:  clat=',clat, ' clon=',clon
        print*,'  DOMAIN.INFO:   clat=',clatx,' clon=',clonx
        print*,'  domain.param:  plat=',plat, ' plon=',plon
        print*,'  DOMAIN.INFO:   plat=',platx,' plon=',plonx
        stop 782
      end if
      if (iprojx.ne.iproj) then
        print*,'DOMAIN.INFO is inconsistent with domain.param'
        print*,'  domain.param: iproj=',iproj
        print*,'  DOMAIN.INFO:  iproj=',iprojx
        stop 783
      end if
      read (10,rec=5) ((xlatx(i,j),j=1,jx),i=1,iy)
      read (10,rec=6) ((xlonx(i,j),j=1,jx),i=1,iy)
      close(10)
      idot = 0
      do j=1,nx
      do i=1,ny
        xlat(i,j) = xlatx(i+1,j+1)
        xlon(i,j) = xlonx(i+1,j+1)
      end do
      end do

C ****** SET UP LONGITUDES AND LATITUDES FOR LAT/LON GRID
      DO NLO=1,NLON
        LONI(NLO) = GLON1 + dlon*FLOAT(NLO-1)
      end do
      DO NLA=1,NLAT
        LATI(NLA) = GLAT1 + dlat*FLOAT(NLA-1)
      end do

C ****** SET UP NetCDF STUFF
      print*,'CALL PARAM'
      CALL PARAM(nx,ny,1,ds,ddeg,clat,clon,plat,plon
     &   , xlat,xlon,vvarmin,vvarmax,xlat1d,xlon1d,idim,ndim)
      print*,vvarmin,vvarmax
      sigf(1) = 1.
      sigf(2) = 1.
      sig1d(1) = 1.
      idatex0 = idatecru0*10000 + 1500
      idatex1 = idatecru1*10000 + 1500
      idatex2 = idatecru2*10000 + 1500
      CALL SPLITDATE (idatex0,idt0)
      CALL SPLITDATE (idatex1,idt1)
      CALL SPLITDATE (idatex2,idt2)

      aaa=2.**16.-1.
C ****** READ/WRITE DATA
      do ifld=1,nfld
        print*,'OPENING NetCDF FILE: ',outfile(ifld)
        idcdf = NCOPN(infile(ifld),ncnowrit,ierr) ! Open input file
        CALL rcrecdf (outfile(ifld),ncid,vvarmin,vvarmax,3,ierr)
        idatex = idatex1
        imo = idt1(2)
        iyr = idt1(1)
        idyr = idt1(1)-idt0(1)
        if (idyr.lt.0) idyr = 0
        idmo = idt1(2)-idt0(2)
        itim = idyr*12 + idmo + 1
        print*,'ITIM=',itim
        DO while (idatex.le.idatex2)
          if (ifld.eq.10) then  ! ELEVATION
            idatex=1975011500
            itim=1
          end if
          CALL JULIAN(idatex,julnc,iyr,imo,idy,ihr)
          xhro = float(julnc)
          PRINT*,'READ/WRITE: ',vnam(ifld),idatex,itim,xhro
          CALL READCDF3D(idcdf,infile(ifld),itim,vnam(ifld)
     &           , gridlalo,scale,offset,vmisdat,lnam,units)
          CALL BILINX(GRIDLALO,LONI,LATI,NLON,NLAT
     A       , GRIDRCM,XLON,XLAT,NY,NX,1,xmin,vmisdat)
          do j=1,ny
          do i=1,nx
            gridnc(i,j) = gridrcm(j,i)
          end do
          end do
          CALL WRITECDF(ncid,vnam(ifld),gridnc,nx,ny,1,idim
     &       , xhro,lnam,units,scale,offset
     &       , vvarmin,vvarmax,xlat1d,xlon1d,sig1d,0,xmin,2)
          imo = imo + 1
          if (imo.gt.12) then
            imo = 1
            iyr = iyr + 1
          end if
          idatex = iyr*1000000 + imo*10000 + 1500
          if (ifld.eq.10) idatex=idatex2+1  ! Elevation
          itim = itim + 1
          print*,idatex,idatex2
        end do
        call clscdf(ncid,ierr)
      end do

      END

      SUBROUTINE JULIAN(idate,julnc,iyr,imo,idy,ihr)

      implicit none
      integer lenmon(12), jprev(12), ileap, j, julnc, julday
      integer iyr,imo,idy,ihr,idate,iyrm1

      data lenmon / 31, 28, 31, 30, 31, 30
     &            , 31, 31, 30, 31, 30, 31 /

      iyr = idate/1000000
      imo = idate/10000-iyr*100
      idy = idate/100-iyr*10000-imo*100
      ihr = idate-idate/100*100
      ileap = mod(iyr,4)
      if(ileap.eq.0) then
        lenmon(2) = 29
      else
        lenmon(2) = 28
      end if

      if (ihr.gt.23) then
        ihr = ihr - 24
        idy = idy + 1
      end if
      if (idy.gt.lenmon(imo)) then
        idy = 1
        imo = imo + 1
      end if
      if (imo.gt.12) then
        imo = 1
        iyr = iyr + 1
      end if
      idate = iyr*1000000 + imo*10000 + idy*100 + ihr

      iyrm1 = iyr - 1


      jprev(1) = 0
      do j=2,12
        jprev(j)  = jprev(j-1) + lenmon(j-1)
      end do

      julday = idy + jprev(imo) - 1

      julnc = ((iyr-1900)*365 + julday + int((iyrm1-1900)/4))*24 + ihr

      return
      end

      SUBROUTINE READCDF3D(idcdf,infil,itim,varnam
     &         , vals,scale,offset,vmisdat,lnam,units)

      implicit none
      include 'cru.param'
      character infil*(*),varnam*(*),dumnam*31,lnam*(*),units*(*)
	
      real*4 scale,offset,error,vmisdat
      real vals(nlon,nlat)
      integer*2 igrid2d(nlon,nlat),imisdat
      integer*4 istart(3),icount(3)
     &	 ,idcdf,iflag,latid,lonid,timid,invarid
     &	 ,latsiz,lonsiz,timsiz
     &      , idcdfout, ncopn, ncdid, ncvid, ncnowrit
      integer itim,i,j

c *** Check to make sure dimensions match ***
      latid = NCDID(idcdf, 'lat', iflag)
      CALL NCDINQ(idcdf, latid, dumnam, latsiz, iflag)
      lonid = NCDID(idcdf, 'lon', iflag)
      CALL NCDINQ(idcdf, lonid, dumnam, lonsiz, iflag)
      timid = NCDID(idcdf, 'time', iflag)
      CALL NCDINQ(idcdf, timid, dumnam, timsiz, iflag)
      if (latsiz.ne.nlat .or. lonsiz.ne.nlon .or. itim.gt.timsiz) then
        print*,'DECLARED DIMENSIONS AND DATA DEMENSIONS DO NOT MATCH'
        print*,'  LAT: latsiz=',latsiz,' nlat=',nlat
        print*,'  LON: lonsiz=',lonsiz,' nlon=',nlon
        print*,' TIME: timsiz=',timsiz,' itim=',itim
        print*,'latid,lonid,timid'
        print*,lonid,latid,timid
        print*,varnam
        stop 999
      end if
      istart(timid) = itim
      istart(lonid) = 1
      istart(latid) = 1
      icount(timid) = 1
      icount(lonid) = nlon
      icount(latid) = nlat

c  /*get variable and attributes*/
      invarid = NCVID(idcdf, varnam, iflag)
      CALL NCVGT(idcdf, invarid, istart, icount, igrid2d, iflag)
      CALL NCAGT (idcdf, invarid, 'add_offset', offset, iflag)
      CALL NCAGT (idcdf, invarid, 'scale_factor', scale, iflag)
      CALL NCAGT (idcdf, invarid, 'missing_value', imisdat, iflag)
      CALL NCAGTC (idcdf, invarid, 'long_name', lnam, 50, iflag)
      CALL NCAGTC (idcdf, invarid, 'units', units, 50, iflag)

      do j=1,nlat
      do i=1,nlon
        if (igrid2d(i,j).gt.-32767) then
          vals(i,j) = float(igrid2d(i,j))*scale + offset
        else
          vals(i,j) = vmisdat
        end if
      end do
      end do

      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE BILINX(  IN, LONI, LATI, NLONI, NLATI
     A                 , OUT, LONO, LATO,    IY,    JX, NFLDS
     &                 , xming, vmisdat)
CCC   SUBROUTINE BILINX (B3,B2,XLONS,XLATS,G4LON,G4LAT,NLON2,NLAT2
CCC  A,                 NLON4,NLAT4,NVECTS,NIN,NJN,INDX)
C
C  PERFORMING BI-LINEAR INTERPOLATION USING 4 GRID POINTS FROM A BIGGER
C  RECTANGULAR GRID TO A GRID DESCRIBED BY XLONS AND XLATS OF GRID2.
C  A POINT ON GRID2 IS TRAPPED WITHIN FOUR GRID POINTS ON GRID4.THE
C  GRID POINTS ARE ALWAYS TO THE NORTH AND EAST OF THE TRAPPED POINT.
C  THE ALGORITHM COMPUTES THE FRACTIONAL DISTANCES IN BOTH X AND Y
C  DIRECTION OF THE TRAPPED GRID POINT AND USES THE INFORMATION
C  AS WEIGHTING FACTORS IN THE INTERPOLATION.
C  THERE IS ONE LESS ROW AND COLUMN WHEN THE SCALAR FIELDS ARE
C  INTERPOLATED BECAUSE XLATS AND XLONS ARE NOT DEFINED FOR
C  THE CROSS POINTS IN THE RCM MODEL.
C
C  IN(NLONI,NLATI,NFLDS)  IS THE INPUT FIELD ON REGULAR LAT/LON GRID.
C  OUT(NLATO,NLONO,NFLDS) IS THE OUTPUT FIELD ON LAMBERT CONFORMAL GRID.
C  LONI.....LONGITUDE VALUES IN DEGREES OF THE LAT-LON GRID.
C  LATI.....LATITUDE VALUES IN DEGREES OF THE LAT-LON GRID.
C  P.........EAST-WEST WEIGHTING FACTOR.
C  Q.........NORTH-SOUTH WEIGHTING FACTOR.
C  IP........GRID POINT LOCATION IN EAST-WEST OF TRAPPED GRID POINT.
C  IQ........GRID POINT LOCATION IN NORTH-SOUTH OF TRAPPED GRID POINT.
 
      REAL  IN(NLONI,NLATI,NFLDS), LONI(NLONI), LATI(NLATI)
      REAL OUT(IY,JX,NFLDS), LONO(IY,JX), LATO(IY,JX)
      REAL LON360
 
      DO 120 J=1,JX
      DO 110 I=1,IY
 
      YIND = (((LATO(I,J)-LATI(1))/(LATI(NLATI)-LATI(1)))
     A     * FLOAT(NLATI-1))+1.
      JQ=INT(YIND)
      JQP1=MIN0(JQ+1,NLATI)
      Q=YIND-JQ
 
      LON360 = LONO(I,J)
cjsp  IF(LONO(I,J).LT.0.) LON360 = LONO(I,J) + 360.
      XIND = (((LON360   -LONI(1))/(LONI(NLONI)-LONI(1)))
     A     * FLOAT(NLONI-1))+1.
      IP=INT(XIND)
      IPP1=MIN0(IP+1,NLONI)
      P=XIND-IP
 
        DO 100 L=1,NFLDS

          if (in(ip,jq,l).le.xming.and.in(ipp1,jq,l).gt.xming) then
            temp1 = in(ipp1,jq,l) 
          elseif(in(ip,jq,l).le.xming.and.in(ipp1,jq,l).le.xming) then
            temp1 = vmisdat
          elseif(in(ip,jq,l).gt.xming.and.in(ipp1,jq,l).le.xming) then
            temp1 = in(ip,jq,l)
          else
            temp1 = (1.0-p)*in(ip,jq,l) + p*in(ipp1,jq,l)
          endif
    
          if (in(ipp1,jqp1,l).le.xming.and.in(ip,jqp1,l).gt.xming) then
            temp2 = in(ip,jqp1,l) 
          elseif(in(ipp1,jqp1,l).le.xming
     &           .and.in(ip,jqp1,l).le.xming) then
            temp2 = vmisdat
          elseif(in(ipp1,jqp1,l).gt.xming
     &           .and.in(ip,jqp1,l).le.xming) then
            temp2 = in(ipp1,jqp1,l)
          else
            temp2 = p*in(ipp1,jqp1,l) + (1.0-p)*in(ip,jqp1,l)
          endif
  
          if(temp1.eq.xming.and.temp2.ne.xming) then
            out(i,j,l) = temp2
          elseif(temp1.eq.xming.and.temp2.eq.xming) then
            out(i,j,l) = xming
          elseif(temp1.ne.xming.and.temp2.eq.xming) then
            out(i,j,l) = temp1
          else
            out(i,j,l) = (1. - q)*temp1 + q*temp2
          endif

  100   CONTINUE
  110 CONTINUE
 
  120 CONTINUE
 
      RETURN
      END

      SUBROUTINE MAPLAM( XLON, XLAT, XMAP, CORIOL, IY, JX
     A                 , CLON, CLAT, DELX, IDOT )
 
      REAL XLON(IY,JX), XLAT(IY,JX), XMAP(IY,JX), CORIOL(IY,JX)
      REAL CLON, CLAT, DELX
 
C  COMPUTE LATS, LONS, MAP-SCALE FACTORS, AND CORIOLIS PARAMETER FOR
C  LAMBERT CONFORMAL MAP CENTERED AT CLON,CLAT. TRUE AT 30.N AND 60.N.
 
C  IY IS NUMBER OF N-S POINTS.  JX IS NUMBER OF E-W POINTS.
C  CLON, CLAT IS LAT, LON OF CENTER OF GRID (DEGREES EAST, NORTH).
C  DELX IS GRID SPACING IN METERS.
C  IDOT=1 FOR DOT GRID, 0 FOR CROSS GRID.
C  CORIOLIS FACTOR DEFINED ON DOT GRID ONLY.

      XOMEGA=7.2722E-5              ! ANG. ROT OF EARTH IN S**-1
      GRDFAC=.716                   ! FACTOR FOR LAMBERT CONFORMAL
      EARTHR=6.37E6                 ! METERS
      PSI1=30.                      ! LAT AT WHICH PROJ. IS TRUE
C                                   !   TRUE AT COLAT OF PSI1 TOO
      PIFAC=ATAN(1.)/45.            ! CONVERT DEGREES TO RADIANS
      PSI0=90.-CLAT                 ! COLAT OF CENTER
C
      PSI1=PIFAC*PSI1               ! CONVERT TO RADIANS
      PSI0=PIFAC*PSI0               ! CONVERT TO RADIANS
      RGRDF=1./GRDFAC               ! RECIPROCAL OF GRID FACTOR
      ANS=EARTHR*SIN(PSI1)*RGRDF    ! A*SIN(PS1)/N
      C1=-CLON-90.*RGRDF
      C2=ANS*(TAN(PSI0*0.5)/TAN(PSI1*0.5))**GRDFAC
      PF=TAN(PSI1*0.5)/(ANS**RGRDF)
      XMF=SIN(PSI1)/(TAN(0.5*PSI1)**GRDFAC)
      PI90=2.*ATAN(1.)              ! PI OVER TWO (90 DEGREES)
C
      YC=0.5*FLOAT(IY+IDOT)
      XC=0.5*FLOAT(JX+IDOT)
      DO 10 J=1,JX
      X=(J-XC)*DELX
      DO 10 I=1,IY
      Y=(I-YC)*DELX
      IF (X.NE.0.) THEN
         XLP=ATAN2(Y-C2,X)
         R=ABS(X/COS(XLP))
      ELSE
         XLP=-PI90
         R=ABS(Y-C2)
      ENDIF
      PSI=ABS(2.*ATAN(PF*(R**RGRDF)))        ! CO LATITUDE (RADIANS)
      PFI=PI90-PSI
      XLON(I,J)=XLP*RGRDF/PIFAC-C1           ! LONGITUDE DEGREES EAST
      XLAT(I,J)=PFI/PIFAC                    ! LATITUDE DEGREES NORTH
      XMAP(I,J)=(XMF/SIN(PSI))*(TAN(0.5*PSI)**GRDFAC)
   10 CONTINUE
C
      IF (IDOT.EQ.1) THEN
         XOMEG2=2.*XOMEGA
         DO 20 I=1,IY
         DO 20 J=1,JX
         CORIOL(I,J)=XOMEG2*SIN(XLAT(I,J)*PIFAC)
   20    CONTINUE
      ENDIF
 
      RETURN
      END


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MAPMER( XLON, XLAT, XMAP, CORIOL, IY, JX 
     A                 , CLON,CLAT, POLLON, POLLAT, DS, IDOT)    
      implicit none
C---------------------------------------------------------------------  
C  COMPUTE LATS, LONS, MAP-SCALE FACTORS, AND CORIOLIS PARAMETER FOR
C  ROTATED POLE MAP CENTERED AT CLON,CLAT. ORIGIN OF ROTATED GRID IS
C  GIVEN BY POLLON AND POLLAT.
C  IMX,JMX,KSV,KSH AND LSIG2 MUST CORRESPOND TO IY,JMAX,KSTRPV,KSTRPH 
C  AND NVERT2 IN THE MASTER INPUT FILE; OTHERWISE THE PROGRAM WILL      
C  ABORT:LMX MUST BE THE MAXIMUM NUMBER OF LEVELS (PRESSURE--OR--SIGMA) 
C  IMAXN AND IMXC ARE NESTED AND NON-EXPANDED GRID DIMENSIONS. IMXC IS  
C  EQUAL TO IMX IF YOU ARE NOT USING THE EXPANDED GRID. SAME FOR J.     

      INTEGER IY,JX,IDOT
      REAL*4  XLAT(IY,JX),XLON(IY,JX), CORIOL(IY,JX),XMAP(IY,JX)
      REAL*4  CLON,CLAT,POLLON,POLLAT,DS
C
      REAL*4  XOMEGA,PIFAC,PFINV,A,CNTRJ,CNTRI,DDEG,XOFF,YOFF
      REAL*4  XR,YR,X,Y,FAI,XOMEGA2
      INTEGER I,J
      LOGICAL SOUTHH
      REAL*4  ZLAT,ZPLAT,AAA
C
      IF(CLAT.LT.0.) THEN
         SOUTHH=.true.
         ZLAT  =-CLAT
         ZPLAT =-POLLAT
      ELSE
         SOUTHH=.false.
         ZLAT  = CLAT
         ZPLAT = POLLAT
      ENDIF
C
      XOMEGA = 7.2722E-5                       ! ANG. ROT OF EARTH IN S**-1
      PIFAC = ATAN(1.)/45.                     ! CONVERT DEGREES TO RADIANS
      PFINV = 1./PIFAC                         ! CONVERT RADIANS TO DEGREES
      A = 6371229.                             ! RADIUS OF EARTH IN METERS
C-----CENTER OF GRID
      CNTRJ = (JX+IDOT)/2.
      CNTRI = (IY+IDOT)/2.

      DDEG=DS*PFINV/A                          ! GRID SPACING IN DEGREES
      XOFF=CLON-POLLON
      YOFF=ZLAT-ZPLAT
C-----CALCULATE X AND Y POSITIONS OF GRID                               
      DO 41 I=1,IY
      DO 41 J=1,JX                                                    
        XR = XOFF + (J-CNTRJ)*DDEG                                            
        YR = YOFF + (I-CNTRI)*DDEG
        YR = 2*PFINV*ATAN(EXP(PIFAC*YR))-90.    
C-----NOW CALCULATE LAT AND LON OF THIS POINT                           
C-----  ROTATE COORDINATES BACK TO NONRATED POLE
        CALL ROT2NROT(XR,YR,POLLON,ZPLAT,X,Y)
        XLON(I,J) = X
        XLAT(I,J) = Y
        FAI = PIFAC*YR
        XMAP(I,J) = 1.0/COS(FAI)
   41 CONTINUE

      IF(IDOT.EQ.1) THEN
         XOMEGA2=2.*XOMEGA
         DO 45 I=1,IY
         DO 45 J=1,JX
            CORIOL(I,J)=XOMEGA2*SIN(XLAT(I,J)*PIFAC)
   45    CONTINUE
      END IF
      IF(SOUTHH) THEN
         DO J=1,JX
         DO I=1,IY/2
            AAA = XLON(IY+1-I,J)
            XLON(IY+1-I,J) = XLON(I,J)
            XLON(I,J) = AAA

            AAA =-XLAT(IY+1-I,J)
            XLAT(IY+1-I,J) =-XLAT(I,J)
            XLAT(I,J) = AAA

            AAA = XMAP(IY+1-I,J)
            XMAP(IY+1-I,J) = XMAP(I,J)
            XMAP(I,J) = AAA

            IF(IDOT.EQ.1) THEN
            AAA =-CORIOL(IY+1-I,J)
            CORIOL(IY+1-I,J) =-CORIOL(I,J)
            CORIOL(I,J) = AAA
            ENDIF
         ENDDO
         ENDDO
      ENDIF
      RETURN
      END


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE rot2nrot(LAMS,PHIS,POLLON,POLLAT,LAM,PHI)
      implicit none
c----------------------------------------------------------------------------
c Purpose:
c     Adaption of the DWD-Functions to convert rotated pole coordinates
c     (PHIS,LAMS) into geogrphic coordinates (PHI,LAM). The location of 
c     the rotated pole is passed trough POLLON and POLLAT. POLLON and
c     POLLAT give the origin of the rotated grid. The 
c     first four arguments are input, the last two are output. All angles 
c     are in degrees (north>0, east>0)
c History:
c     05/90   D.MAJEWSKI (DWD)
c     03/93   D.BRESCH (ETHZ)
c     09/96   D.LUETHI (ETHZ)
 
c declaration of arguments:
      REAL*4  LAMS,PHIS,PPHI,PLAM,PHI,LAM,POLLON,POLLAT
 
c declaration of internal vars:
      real*4  zarg1,zarg2
      real*4  zphis,zlams,arg
 
      real*4  ZRPI18,ZPIR18
      DATA    ZRPI18,ZPIR18  / 57.2957795 , 0.0174532925 /
      real*4  ZSINPOL,ZCOSPOL,ZLAMPOL
 
      PLAM=POLLON + 180.
cjsp  IF (POLLAT.GT.0.) THEN
      IF (POLLAT.GE.0.) THEN
        PPHI = 90. - POLLAT
      ELSE
        PPHI = 90. + POLLAT
        PLAM = PLAM - 180.
      ENDIF

      IF (PLAM.GT.180.) PLAM = PLAM-360.
      ZSINPOL = SIN(ZPIR18*PPHI)
      ZCOSPOL = COS(ZPIR18*PPHI)
      ZLAMPOL =     ZPIR18*PLAM

c do case without rotated pole
c      if (abs(pphi-90.).lt.1.e-3) then
c        phi=phis
c        lam=lams
c        return
c      endif
 
C first, the conversion of PHIS to PHI:
      ZPHIS  = ZPIR18*PHIS
      ZLAMS  = LAMS
      IF(ZLAMS.GT.180.0) ZLAMS = ZLAMS - 360.0
      ZLAMS  = ZPIR18*ZLAMS
      ARG     = ZCOSPOL*COS(ZPHIS)*COS(ZLAMS) + ZSINPOL*SIN(ZPHIS)
      PHI = ZRPI18*ASIN(ARG)
 
c follows conversion of LAMS to LAM:
      ZPHIS   = ZPIR18*PHIS
      ZLAMS   = LAMS
      IF(ZLAMS.GT.180.0) ZLAMS = ZLAMS - 360.0
      ZLAMS   = ZPIR18*ZLAMS
      ZARG1   = SIN(ZLAMPOL)*(- ZSINPOL*COS(ZLAMS)*COS(ZPHIS)  +
     &                          ZCOSPOL*           SIN(ZPHIS)) -
     &          COS(ZLAMPOL)*           SIN(ZLAMS)*COS(ZPHIS)
      ZARG2   = COS(ZLAMPOL)*(- ZSINPOL*COS(ZLAMS)*COS(ZPHIS)  +
     &                          ZCOSPOL*           SIN(ZPHIS)) +
     &          SIN(ZLAMPOL)*           SIN(ZLAMS)*COS(ZPHIS)
      IF (ABS(ZARG2).LT.1.E-30) THEN
        IF (ABS(ZARG1).LT.1.E-30) THEN
          LAM =   0.0
        ELSEIF (ZARG1.GT.0.) THEN
          LAM =  90.0
        ELSE
          LAM = -90.0
        ENDIF
      ELSE
        LAM = ZRPI18*ATAN2(ZARG1,ZARG2)
      ENDIF

      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE MAPPOL( XLON, XLAT, XMAP, CORIOL, IY, JX
     A                 , CLON, CLAT, DELX, idot )
      implicit none
      INTEGER IY,JX
      REAL*4  CLON,CLAT,DELX

      REAL*4  XLON(IY,JX), XLAT(IY,JX)
      REAL*4  XMAP(IY,JX), CORIOL(IY,JX)
      REAL*4  XN,PSI1,PI
C
C         XN IS CONE FACTOR FOR THE PROJECTION (FROM PROGRAM TERRAIN).
C         PSI1 IS THE COLATITUDE OF TRUELAT 1, IN RADIANS.
C         PI IS PI.
C
C---------------------------------------------------------------------
      REAL*4  AA,POLE,DEGRAN
      REAL*4  CNTRJ,CNTRI,PSX,CELL,CELL2,R,XCNTR,YCNTR
      REAL*4  X,Y,FLP,FLPP,CELL1,PSIX,xomega,xomeg2,pifac
      INTEGER II1,JJ1,I,J,idot

C  COMPUTE LATS, LONS, AND MAP-SCALE FACTORS FOR
C  LAMBERT CONFORMAL MAP CENTERED AT CLON,CLAT. TRUE AT 30.N AND 60.N.

C  IY IS NUMBER OF N-S POINTS.  JX IS NUMBER OF E-W POINTS.
C  CLON, CLAT IS LAT, LON OF CENTER OF GRID (DEGREES EAST, NORTH).
C  DELX IS GRID SPACING IN METERS.
C  ALWAYS FOR CROSS GRID.

C
      AA=6.371229E6
      XN=1.0
      PI=ATAN(1.)*4.
      DEGRAN=PI/180.
C
      POLE=90.
      PSI1=30.
      PSI1=PSI1*DEGRAN
      IF (CLAT.LT.0.0) THEN
         POLE = -90.0
         PSI1 = -30.
         PSI1=PSI1*DEGRAN
      ENDIF
      CNTRJ = FLOAT(JX+idot)/2.
      CNTRI = FLOAT(IY+idot)/2.
C
      PSX = (POLE-CLAT)*DEGRAN
      CELL=AA*SIN(PSX)/XN
      CELL2 = (1. + COS(PSI1))/(1. + COS(PSX))
      R=CELL*(CELL2)**XN
      XCNTR=0.
      YCNTR=-R
C
      II1 = IY
      JJ1 = JX
      DO 70 I=1,II1
         Y=YCNTR+(I-CNTRI)*DELX
         DO 70 J=1,JJ1
            X=XCNTR+(J-CNTRJ)*DELX
            R = SQRT(X*X + Y*Y)
            IF(Y.EQ.0.) THEN
               IF(X.GE.0.) THEN
                  FLP=90.*DEGRAN
               ELSE
                  FLP=-90.*DEGRAN
               ENDIF
            ELSE
               IF (CLAT.LT.0.0) THEN
                  FLP = ATAN2(X,Y)
               ELSE
                  FLP = ATAN2(X,-Y)
               END IF
            END IF
            FLPP = FLP/XN/DEGRAN+CLON
            IF (FLPP.GT.180.0) FLPP = FLPP-360.0
            IF (FLPP.LT.-180.0) FLPP = FLPP+360.0
            XLON(I,J) = FLPP
            IF (CLAT.LT.0.0) R = -R
            CELL = R/AA
            CELL1 = CELL/(1.0 + COS(PSI1))
            CELL2=ATAN(CELL1)
            PSX=2.*CELL2/DEGRAN
            XLAT(I,J) = POLE - PSX
            PSIX=PSX*DEGRAN
            XMAP(I,J) = ((1.0 + COS(PSI1))/(1.0 + COS(PSIX)))**XN
 70   CONTINUE

      IF (IDOT.EQ.1) THEN
         XOMEGA = 7.2722E-5           ! ANG. ROT OF EARTH IN S**-1
         PIFAC = ATAN(1.)/45.         ! CONVERT DEGREES TO RADIANS
         XOMEG2=2.*XOMEGA
         DO I=1,IY
         DO J=1,JX
           CORIOL(I,J)=XOMEG2*SIN(XLAT(I,J)*PIFAC)
         end do
         end do
      ENDIF
      RETURN
      END



      SUBROUTINE MAPROT( XLON, XLAT, XMAP, CORIOL, IMAX, JMAX 
     A                 , XLONC, PHIC, POLLON, POLLAT, DS, IDOT)    
C---------------------------------------------------------------------  
C  COMPUTE LATS, LONS, MAP-SCALE FACTORS, AND CORIOLIS PARAMETER FOR
C  ROTATED POLE MAP CENTERED AT CLON,CLAT. ORIGIN OF ROTATED GRID IS
C  GIVEN BY POLLON AND POLLAT.
C  IMX,JMX,KSV,KSH AND LSIG2 MUST CORRESPOND TO IMAX,JMAX,KSTRPV,KSTRPH 
C  AND NVERT2 IN THE MASTER INPUT FILE; OTHERWISE THE PROGRAM WILL      
C  ABORT:LMX MUST BE THE MAXIMUM NUMBER OF LEVELS (PRESSURE--OR--SIGMA) 
C  IMAXN AND IMXC ARE NESTED AND NON-EXPANDED GRID DIMENSIONS. IMXC IS  
C  EQUAL TO IMX IF YOU ARE NOT USING THE EXPANDED GRID. SAME FOR J.     

      real XLAT(IMAX,JMAX),XLON(IMAX,JMAX),CORIOL(IMAX,JMAX)
     &    ,XMAP(IMAX,JMAX), XLONC, PHIC, POLLON, POLLAT, DS
C                                                                       
      XOMEGA = 7.2722E-5                       ! ANG. ROT OF EARTH IN S**-1
      PIFAC = ATAN(1.)/45.                     ! CONVERT DEGREES TO RADIANS
      PFINV = 1./PIFAC                         ! CONVERT RADIANS TO DEGREES
      A = 6370000.                             ! RADIUS OF EARTH IN METERS
C-----CENTER OF GRID                                                    
      CNTRJ = JMAX/2.                                                    
      CNTRI = IMAX/2.                                                    
      PRINT 10,PHIC,XLONC                                               
   10 FORMAT(1X,'LATITUDE AND LONGITUDE OF CENTER OF GRID = ',F8.3,'N', 
     1 F8.3,'W')                                                        

      DDEG=DS*PFINV/A                    ! GRID SPACING IN DEGREES
      XOFF=XLONC-POLLON
      YOFF=PHIC-POLLAT
C-----CALCULATE X AND Y POSITIONS OF GRID                               
      DO 41 I=1,IMAX                                                    
      DO 41 J=1,JMAX                                                    
        XR = XOFF + (J-CNTRJ)*DDEG                                            
        YR = YOFF + (I-CNTRI)*DDEG                                            
C-----NOW CALCULATE LAT AND LON OF THIS POINT                           
C-----  ROTATE COORDINATES BACK TO NONRATED POLE
        CALL ROT2NROT(XR,YR,POLLON,POLLAT,X,Y)
        XLON(I,J) = X
        XLAT(I,J) = Y
        FAI = PIFAC*YR
        XMAP(I,J) = 1.0/COS(FAI)
   41 CONTINUE                                                          

      IF(IDOT.EQ.1) THEN
         XOMEGA2=2.*XOMEGA
         DO 45 I=1,IMAX
         DO 45 J=1,JMAX
            CORIOL(I,J)=XOMEGA2*SIN(XLAT(I,J)*PIFAC)
   45    CONTINUE
      END IF

      RETURN                                                            
      END

      SUBROUTINE SPLITDATE (idate,idt)

      integer idt(4)

      idt(1) = idate/1000000
      idt(2) = idate/10000-idt(1)*100
      idt(3) = idate/100-idt(1)*10000-idt(2)*100
      idt(4) = idate-idt(1)*1000000-idt(2)*10000-idt(3)*100

      return
      end


      SUBROUTINE PARAM(nx,ny,kz,ds,ddeg,clat,clon,xplat,xplon
     &         , xlat,xlon,vvarmin,vvarmax,xlat1d,xlon1d,idim,ndim)

      real   vvarmin(ndim), vvarmax(ndim), xlat1d(ny), xlon1d(nx)
      real xlat(ny,nx), xlon(ny,nx)
      integer idim(ndim)

      ddeg=ds*180./3.14159265359/6370000.
      print*,'DS=',ds,'DDEG=',ddeg
      vvarmin(1) = xlon(ny/2,1)
      vvarmin(2) = xlat(1,nx/2)
      vvarmin(3) = 1050.
      vvarmax(1) = xlon(ny/2,nx)
      vvarmax(2) = xlat(ny,nx/2)
      vvarmax(3) = 1050.
      idim(1) = nx
      idim(2) = ny
      idim(3) = kz
      do i=1,nx
        xlon1d(i) = xlon(ny/2,i)
      end do
      do j=1,ny
        xlat1d(j) = xlat(j,nx/2)
      end do

      return
      end


