
      SUBROUTINE CRECDF (filnam, cdfid, phymin, phymax, ndim, error) 

      include 'netcdf.inc'

      integer        MAXDIM
      parameter      (MAXDIM=4)
      integer        ndim, error
      character *(*) filnam
      real           phymin(*), phymax(*)

      character *(20) attnam
      character *(1)  chrid(MAXDIM)
      integer         cdfid, k, ibeg, iend, lenfil, ncopts
      data            chrid/'x','y','z','a'/

      integer        strbeg, strend

      error = 0

      error = NF_CREATE (filnam(1:strend(filnam)), NF_CLOBBER, cdfid)
      if (error.ne.0) go to 920

      do k=1,ndim
        attnam(1:3)='dom'
        attnam(4:4)=chrid(k)
        attnam(5:7)='min'
        attnam=attnam(1:7)
        error = NF_PUT_ATT_REAL(cdfid,NF_GLOBAL,attnam,NF_FLOAT,1,
     &          phymin(k))
        if (error.gt.0) goto 920

        attnam(1:3)='dom'
        attnam(4:4)=chrid(k)
        attnam(5:7)='max'
        attnam=attnam(1:7)
        error =  NF_PUT_ATT_REAL(cdfid,NF_GLOBAL,attnam,NF_FLOAT,1,
     &           phymax(k))
        if (error.gt.0) goto 920
      enddo

      error =  NF_ENDDEF (cdfid)
      if (error.gt.0) goto 920

      return
 920  write (6, *) 'ERROR: An error occurred while attempting to ',
     &             'create the data file in subroutine crecdf.'
      error =  NF_CLOSE (cdfid)
      end


      SUBROUTINE RCRECDF (filnam,cdfid,varmin,varmax,ndim,ierr)
      character*(*) filnam
      integer       cdfid,ierr
      real*4        varmin(ndim),varmax(ndim)

      CALL CRECDF (filnam,cdfid,varmin,varmax,3,ierr)

      end

      FUNCTION RMAX(ar,n)
      dimension ar(n)
      rmax=ar(1)
      do i=2,n
        if (ar(i).gt.rmax) rmax=ar(i)
      enddo
      end


      FUNCTION RMIN(ar,n)
      dimension ar(n)
      rmin=ar(1)
      do i=2,n
        if (ar(i).lt.rmin) rmin=ar(i)
      enddo
      end

      SUBROUTINE CLSCDF (cdfid, error)

      include 'netcdf.inc'

      integer      cdfid, error
      integer      ncopts
      error = NF_CLOSE (cdfid)
      if (error.ne.0) call handle_err(error)

      end


      SUBROUTINE WRITECDF(cdfid,varnam,arr,ie,je,ke,idim,vtstep,
     &  lname,unit,factor,offset,vvarmin,vvarmax,xlat1d,xlon1d,sigh
     & ,izstag,vmisdat,iotype)


      include 'netcdf.inc'

      integer    cdfid,idim(3),izstag,ie,je,ke,iotype
      real     arr(ie,je,ke)
      real     xlat1d(je), xlon1d(ie)
      real     vvarmin(3),vvarmax(3)
      real*8     vtstep
      character*(*)  varnam
      character*(*)  lname
      character*(*)  unit
      real*4 varmin(3),varmax(3),varstg(3),vmisdat,tstep,sigh(ke)
      integer*2 mdat
      integer strbeg,strend
      integer idtest,it,error,nvars
      integer vardim(3)
      real*4 offset,factor,rfac
      integer i,j,k,iputlev
      integer ievar,jevar,kevar

      do i=1,3
        varmin(i)=vvarmin(i)
        varmax(i)=vvarmax(i)
      enddo

      tstep  = vtstep
      ievar  = idim(1)
      jevar  = idim(2)
      kevar  = idim(3)
      ndims=4
      vardim(1)=ievar
      vardim(2)=jevar
      vardim(3)=kevar
      varstg(1)=0.
      varstg(2)=0.
      varstg(3)=-0.5
      if (izstag.ne.0) varstg(3)=0.

      error = NF_INQ_VARID(cdfid,varnam(strbeg(varnam):strend(varnam)),
     &        it)

      if (error.ne.0) then
        CALL PUTDEFCDF(cdfid,varnam,ndims,vmisdat,lname,unit
     &    ,  offset,factor,vardim,varmin,varmax,iotype,ierr)
        if (ierr.ne.0) stop '*ERROR* in putdef in writecdf'

        CALL PUTCOORDS(cdfid,ndims,vardim,xlat1d,xlon1d,sigh,ierr)
        if (ierr.ne.0) stop '*ERROR* in putdef in grbtst'
      endif
      do k=1,kevar
        if (kevar.eq.1) then
          iputlev=0
        else
          iputlev=k
        endif
        if (iotype.eq.1) then   ! Integer*2 format
          rfac = 1./factor
          CALL PUTDATCDFI2(cdfid,varnam(strbeg(varnam):strend(varnam))
     & ,      vtstep, k, iputlev, ievar, jevar, kevar, arr, ie, je, ke
     & ,      vmisdat, rfac, offset, ierr) 
        else if (iotype.eq.2) then   ! Real*4 format
          CALL PUTDATCDFR4(cdfid,varnam(strbeg(varnam):strend(varnam))
     & ,      vtstep,k,iputlev,ievar,jevar,kevar,arr,ie,je,ke,ierr)
        end if
      enddo   ! loop over vertical levels

      end


      SUBROUTINE PUTCOORDS(cdfid,ndim,vardim,xlat1d,xlon1d,sigh,ierr)

      integer   vardim(*)
      integer   ierr,i,k,ndim,ii
      real      xlat1d(*),xlon1d(*),sigh(*)

      integer   cdfid,idcoor
      integer   ncvid
      real      actval, delta
      character*(5)  rdim(3)

      data      rdim /'lon  ','lat  ','level'/

      do k=1,max0(ndim,3)
        if (vardim(k).gt.1) then
          ierr = NF_INQ_VARID(cdfid,rdim(k),idcoor)
          if (k.eq.1) then
            if (ierr.eq.0) then
              do i=1,vardim(k)
                actval=xlon1d(i)
                ierr = NF_PUT_VAR1_REAL(cdfid,idcoor,i,actval)
                if (ierr.ne.0) call handle_err(ierr)
              enddo
            endif
          else if (k.eq.2) then
            if (ierr.eq.0) then
              do i=1,vardim(k)
                actval=xlat1d(i)
                ierr = NF_PUT_VAR1_REAL(cdfid,idcoor,i,actval)
                if (ierr.ne.0) call handle_err(ierr)
              enddo
            endif
            else
            if (ierr.eq.0) then
              do i=1,vardim(k)
                ii = vardim(k)-i+1
                actval=sigh(ii)
                ierr = NF_PUT_VAR1_REAL(cdfid,idcoor,i,actval)
                if (ierr.ne.0) call handle_err(ierr)
              enddo
            endif
          end if
        endif
        if (k.gt.3) then
          ierr = 0
        end if
      enddo

      return
      end


      SUBROUTINE PUTDATCDFI2(cdfid, varnam, time, k, level
     &      , ievar, jevar, kevar, arr, ie, je, ke
     &      , vmisdat, rfac, offset, error)

      implicit none
      include 'netcdf.inc'

      character*(*) varnam
      character*(20) chars
      integer cdfid
      integer ie, je, ke, ievar, jevar, kevar, ijmax
      real       arr(ie,je,ke)
      integer*2   dat(ie*je*ke)
      real*4     offset, rfac, vmisdat
      real misdat
      real*8    time, timeval
      real*8    dvrange(2)

      integer   corner(4),edgeln(4),did(4),vardim(4),ndims
      integer   error, ierr
      integer   level,ntime
      integer   idtime,idvar,iflag
      integer   i,j,k,ik,ij
      integer   strend
 
      ij = 0
      do j=1,jevar
      do i=1,ievar
        ij = ij + 1
        if (arr(i,j,k).lt.vmisdat) then 
          dat(ij) = filshort  ! the lowest integer value, should match min
        else 
          dat(ij)=nint((arr(i,j,k)-offset)*rfac)
        endif
      enddo
      enddo
      CALL GETDEFI2 (cdfid, varnam(1:strend(varnam)), ndims, misdat, 
     &                           vardim, ierr)
      if (ierr.ne.0)  print *,'*ERROR* in getdef in putdat'

      ierr = NF_INQ_VARID(cdfid,varnam(1:strend(varnam)),idvar)
      if (ierr.ne.0) print *,'*ERROR* in ncvid in putdat'
      ierr = NF_INQ_DIMID(cdfid,'time',did(4))
      if (ierr.ne.0) print *,'*ERROR* did(4) in putdat'
      ierr = NF_INQ_DIM(cdfid,did(4),chars,ntime)
      if (ierr.ne.0) print *,'*ERROR* in ncdinq in putdat'
      ierr = NF_INQ_VARID(cdfid,'time',idtime)
      if (ierr.ne.0) print *,'*ERROR* in ncvid in putdat'
      iflag=0
      do i=1,ntime
        ierr = NF_GET_VAR1_DOUBLE(cdfid,idtime,i,timeval)
        if (ierr.ne.0) print *,'*ERROR* in ncvgt1 in putdat'
        if (time.eq.timeval) iflag=i
      enddo
      if (iflag.eq.0) then ! new time step
        ntime=ntime+1
        iflag=ntime
        ierr = NF_INQ_VARID(cdfid,'time',idtime)
        if (ierr.ne.0) print *, '*ERROR* in ncvid in putdat'
        ierr = NF_PUT_VAR1_DOUBLE(cdfid,idtime,ntime,time)
        if (ierr.ne.0) print *, '*ERROR* in ncvpt1 in putdat'
        ierr = NF_GET_ATT_DOUBLE(cdfid,idtime,'actual_range',dvrange)
        if ((dvrange(1).gt.time).or.(dvrange(1).eq.0.))
     &         dvrange(1) = time 
        if ((dvrange(2).lt.time).or.(dvrange(2).eq.0.))
     &         dvrange(2) = time
        ierr = NF_PUT_ATT_DOUBLE (cdfid,idtime,'actual_range',NF_DOUBLE,
     &                2,dvrange,ierr)
      endif

      corner(1)=1               ! starting corner of data volume
      corner(2)=1
      edgeln(1)=vardim(1)       ! edge lengthes of data volume
      edgeln(2)=vardim(2)
      if (level.eq.0) then
        ik = 3
      else
        ik = 4
        corner(3)=level
        edgeln(3)=1
      endif
      corner(ik)=iflag
      edgeln(ik)=1
      
      error = NF_PUT_VARA_INT2(cdfid,idvar,corner,edgeln,dat)
      if (error.ne.0) then
        print *, '*ERROR* in ncvpt in putdat - Put data on NetCDF file'
      endif

      ierr = NF_SYNC(cdfid)
      if (ierr.ne.0) print *, '*ERROR* in ncsnc in putdat'
      end


      SUBROUTINE PUTDEFCDF(cdfid,varnam,ndim,misdat,clname
     &         , clunits,offset,scale,vardim,varmin,varmax,iotype,error)

      include 'netcdf.inc'
      integer        MAXDIM
      parameter      (MAXDIM=4)
      character *(*) varnam,clname,clunits
      integer        vardim(*), ndim, error, cdfid, iotype
      real           misdat,  varmin(*), varmax(*)
      real           scale,offset
      character *(20) dimnam,dimchk
      character *(20) dimnams(MAXNCDIM)
      character *(5)  rdim(MAXDIM)
      integer         dimvals(MAXNCDIM)
      integer         numdims,numvars,numgats,dimulim
      integer         id,did(MAXDIM),idtime,i,k,ik,ierr
      integer         ncopts

      integer         ibeg,iend
      integer         idcoor
      real            vrange(2)
      real*8          dvrange(2)
      character*(20)  long_name(MAXDIM)
      character*(30)  units(MAXDIM)
      data            rdim /'lon  ','lat  ','level','time '/
      data            long_name /'Longitude', 'Latitude', 
     &                           'Height_Index', 'Time' /

      data            units / 'degrees_east', 'degrees_north',
     &                 'level' , 'hours since 1900-1-1 00:00:0.0' /


      integer         strbeg, strend

      error = 0

      if (ndim.gt.MAXDIM) then
         error = 10
         go to 900
      endif

      error = NF_INQ(cdfid,numdims,numvars,numgats,dimulim)
      if (numdims.gt.0) then
        do i=1,numdims
          error = NF_INQ_DIM(cdfid,i,dimnams(i),dimvals(i))
        enddo
      endif

      error = NF_REDEF(cdfid)
      if (error.ne.0) goto 920

      ik = 0 
      do k=1,min0(3,ndim)
       if (vardim(k).gt.1) then
        ik = ik + 1
        ibeg=strbeg(rdim(k))
        iend=strend(rdim(k))
        dimnam = '                    '
        dimnam(1:1+iend-ibeg)=rdim(k)(ibeg:iend)
        did(ik)=-1
        if (numdims.gt.0) then
          do i=1,numdims
            dimchk=dimnams(i)
            if ((dimnam(1:3).eq.dimchk(1:3))) then 
              did(ik)=i
              goto 100
            endif
          enddo
 100      continue
        endif
        if ((did(ik).lt.0)) then
          error= NF_DEF_DIM(cdfid,dimnam,vardim(k),did(ik))
          if (error.ne.0) call handle_err(error)
          ierr = NF_DEF_VAR(cdfid,dimnam,NF_FLOAT,1,did(ik),idcoor)
          if (ierr.ne.0) call handle_err(ierr)
          if ((error.ne.0).or.(ierr.ne.0)) goto 920
          vrange(1) = varmin(k)
          vrange(2) = varmax(k)
          iend=strend(long_name(k))
          ierr = NF_PUT_ATT_TEXT(cdfid,idcoor,'long_name',
     &                 iend,long_name(k)(1:iend))
          if(ierr.ne.0) call handle_err(ierr)
          iend=strend(units(k))
          ierr = NF_PUT_ATT_TEXT(cdfid,idcoor,'units',
     &                 iend,units(k)(1:iend))
          if(ierr.ne.0) call handle_err(ierr)
          ierr = NF_PUT_ATT_REAL(cdfid,idcoor,'actual_range',
     &                 NF_FLOAT,2,vrange)
          if(ierr.ne.0) call handle_err(ierr)
        endif
       endif
      enddo

      if (ndim.eq.4) then
        ik = ik +1
        ierr = NF_INQ_DIMID(cdfid,'time',did(ik))
        if (ierr.ne.0) then 
          ierr = NF_DEF_DIM(cdfid,'time',NF_UNLIMITED,did(ik))
        if(ierr.ne.0) call handle_err(ierr)
        endif
        ierr = NF_INQ_VARID(cdfid,'time',idtime)
        if (ierr.ne.0) then 
          ierr = NF_DEF_VAR(cdfid,'time',NF_DOUBLE,1,did(ik),idtime)
          if(ierr.ne.0) call handle_err(ierr)
          ierr = NF_PUT_ATT_TEXT(cdfid,idtime,'long_name',4,'Time')
          if (ierr.ne.0) call handle_err(ierr)
          iend = strend(units(4))
          ierr = NF_PUT_ATT_TEXT(cdfid,idtime,'units',
     &                 iend,units(4)(1:iend))
          if (ierr.ne.0) call handle_err(ierr)
          dvrange(1)=0.
          dvrange(2)=0.
          ierr = NF_PUT_ATT_DOUBLE (cdfid,idtime,'actual_range',
     &                 NF_DOUBLE,2,dvrange)
          if (ierr.ne.0) call handle_err(ierr)
        endif
      endif
      if (iotype.eq.1) then
        error = NF_DEF_VAR(cdfid,varnam,NF_SHORT,ik,did,id)
         if (error.ne.0) call handle_err(error)
      elseif (iotype.eq.2) then
        error = NF_DEF_VAR(cdfid,varnam,NF_FLOAT,ik,did,id)
        if(error.ne.0) call handle_err(error)
      end if
      if (error.ne.0) goto 920
      iend=strend(clname)
      error = NF_PUT_ATT_TEXT(cdfid,id,'long_name',iend,clname)
      if (error.ne.0) call handle_err(error)
      if (error.gt.0) goto 920     

      iend = strend(clunits)
      error = NF_PUT_ATT_TEXT(cdfid,id,'units',iend,clunits)
      if (error.ne.0) call handle_err(error)
      if (error.gt.0) goto 920     

      if (iotype.eq.1) then
        error = NF_PUT_ATT_INT2(cdfid,id,'missing_value',NF_SHORT,1,
     &          filshort)
      elseif (iotype.eq.2) then
        error = NF_PUT_ATT_REAL(cdfid,id,'missing_value',NF_FLOAT,1,
     &          misdat)
        if (error.ne.0) call handle_err(error)
      end if
      if (error.gt.0) goto 920     

      if (iotype.eq.1) then
        error = NF_PUT_ATT_REAL(cdfid,id,'add_offset',NF_FLOAT,1,offset)
        if (error.gt.0) goto 920     
      end if

      if (iotype.eq.1) then
        error = NF_PUT_ATT_REAL(cdfid,id,'scale_factor',NF_FLOAT,1,
     &          scale)
        if (error.gt.0) goto 920    
      end if

      error = NF_ENDDEF(cdfid)
      if (error.ne.0) call handle_err(error)
      if (error.gt.0) goto 920     

      error = NF_SYNC (cdfid)
      if (error.ne.0) call handle_err(error)
      return

 900  write (6, *) '*ERROR*: When calling putcdf, the number of ',
     &             'variable dimensions must be less or equal 4.'
      error = NF_CLOSE (cdfid)
      return

 920  write (6, *) '*ERROR*: An error occurred while attempting to ',
     &             'write the data file in subroutine putcdf.'
      error = NF_CLOSE (cdfid)
      return
      end


      SUBROUTINE PUTDATCDFR4(cdfid, varnam, time, k, level
     &      , ievar, jevar, kevar, arr, ie, je, ke, error)

      implicit none
      include 'netcdf.inc'

      character*(*) varnam
      character*(20) chars
      integer cdfid
      integer ie, je, ke, ievar, jevar, kevar, ijmax
      real     arr(ie,je,ke)
      real*4   dat(ie*je*ke)
      real     misdat
      real*8    time, timeval
      real*8    dvrange(2)

      integer   corner(4),edgeln(4),did(4),vardim(4),ndims
      integer   error, ierr
      integer   level,ntime
      integer   idtime,idvar,iflag
      integer   i,j,k,ik,ij

      integer   strend
 
      ij = 0
      do j=1,jevar
      do i=1,ievar
        ij = ij + 1
        dat(ij)=arr(i,j,k)
      enddo
      enddo

      CALL GETDEFCDFR4(cdfid, varnam(1:strend(varnam)), ndims
     &   , misdat, vardim, ierr)
      if (ierr.ne.0)  print *,'*ERROR* in getdef in putdat'

      ierr = NF_INQ_VARID(cdfid,varnam(1:strend(varnam)),idvar)
      if (ierr.ne.0) print *,'*ERROR* in ncvid in putdat'

      ierr = NF_INQ_DIMID(cdfid,'time',did(4))
      if (ierr.ne.0) print *,'*ERROR* did(4) in putdat'
      ierr = NF_INQ_DIM(cdfid,did(4),chars,ntime)
      if (ierr.ne.0) print *,'*ERROR* in ncdinq in putdat'
      ierr = NF_INQ_VARID(cdfid,'time',idtime)
      if (ierr.ne.0) print *,'*ERROR* in ncvid in putdat'
      iflag=0
      do i=1,ntime
        ierr = NF_GET_VAR1_DOUBLE(cdfid,idtime,i,timeval)
        if (ierr.ne.0) then
          print *,'*ERROR* in ncvgt1 in putdat'
          print*,ntime,cdfid,idtime,i,timeval,ierr
      end if
        if (time.eq.timeval) iflag=i
      enddo
      if (iflag.eq.0) then ! new time step
        ntime=ntime+1
        iflag=ntime
        ierr = NF_INQ_VARID(cdfid,'time',idtime)
        if (ierr.ne.0) print *, '*ERROR* in ncvid in putdat'
        ierr = NF_PUT_VAR1_DOUBLE(cdfid,idtime,ntime,time)
        if (ierr.ne.0) print *, '*ERROR* in ncvpt1 in putdat'
        ierr = NF_GET_ATT_DOUBLE (cdfid,idtime,'actual_range',dvrange)
        if ((dvrange(1).gt.time).or.(dvrange(1).eq.0.))
     &         dvrange(1) = time 
        if ((dvrange(2).lt.time).or.(dvrange(2).eq.0.))
     &         dvrange(2) = time
        ierr = NF_PUT_ATT_DOUBLE (cdfid,idtime,'actual_range',NF_DOUBLE,
     &                2,dvrange)
      endif

      corner(1)=1               ! starting corner of data volume
      corner(2)=1
      edgeln(1)=vardim(1)       ! edge lengthes of data volume
      edgeln(2)=vardim(2)
      if (level.eq.0) then
        ik = 3
      else
        ik = 4
        corner(3)=level
        edgeln(3)=1
      endif
      corner(ik)=iflag
      edgeln(ik)=1
      
      error = NF_PUT_VARA_REAL(cdfid,idvar,corner,edgeln,dat)
      if (error.ne.0) then
        print *, '*ERROR* in ncvpt in putdat - Put data on NetCDF file'
      endif

      ierr = NF_SYNC(cdfid)
      if (ierr.ne.0) print *, '*ERROR* in ncsnc in putdat'
      end


      SUBROUTINE GETDEFI2 (cdfid, varnam, ndim, misdat, 
     &                              vardim, error)

      include 'netcdf.inc'

      integer        MAXDIM
      parameter      (MAXDIM=4)
      character *(*) varnam
      integer        vardim(*), ndim, error, cdfid
      real           misdat

      character *(20) dimnam(MAXNCDIM),vnam
      integer         id,i,k
      integer         ndims,nvars,ngatts,recdim,dimsiz(MAXNCDIM)
      integer         vartyp,nvatts, ncopts

      error = 0

      error = NF_INQ(cdfid,ndims,nvars,ngatts,recdim)
      if (error.eq.1) goto 920

      do i=1,ndims 
        error = NF_INQ_DIM(cdfid,i,dimnam(i),dimsiz(i))
        if (error.gt.0) goto 920
      enddo

      error = NF_INQ_VARID(cdfid,varnam,id)
      if (error.eq.1) goto 910

      error = NF_INQ_VAR(cdfid,id,vnam,vartyp,ndim,vardim,nvatts)
      if (vartyp.ne.NF_SHORT) error=1
      if (error.gt.0) goto 920

      if (ndim.gt.MAXDIM) then
         error = 1
         go to 900
      endif

      do k=1,ndim 
        vardim(k)=dimsiz(vardim(k))
      enddo

      error = NF_GET_ATT_REAL(cdfid,id,'missing_value',misdat)
      if (error.gt.0) goto 920     

      return

 900  write (6, *) '*ERROR*: When calling getcdf, the number of ',
     &             'variable dimensions must be less or equal 4.'
      error = NF_CLOSE (cdfid)
      return

 910  write (6, *) '*ERROR*: The selected variable could not be found ', 
     &             'in the file by getcdf.'
      error = NF_CLOSE (cdfid)
      return

 920  write (6, *) '*ERROR*: An error occurred while attempting to ',
     &             'read the data file in subroutine getcdf.'
      error = NF_CLOSE (cdfid)
      end


      SUBROUTINE GETDEFCDFR4 (cdfid, varnam, ndim, misdat, 
     &                              vardim, error)

      include 'netcdf.inc'

      integer        MAXDIM
      parameter      (MAXDIM=4)
      character *(*) varnam
      integer        vardim(ndim), error, cdfid
      real           misdat

      character *(20) dimnam(MAXNCDIM),vnam
      integer         id,i,k
      integer         ndims,nvars,ngatts,recdim,dimsiz(MAXNCDIM)
      integer         vartyp,nvatts, ncopts

      error = 0

      error = NF_INQ(cdfid,ndims,nvars,ngatts,recdim)
      if (error.eq.1) then
        goto 920
      end if
      do i=1,ndims 
        error = NF_INQ_DIM(cdfid,i,dimnam(i),dimsiz(i))
        if (error.gt.0) then
          goto 920
        end if
      enddo

      error = NF_INQ_VARID(cdfid,varnam,id)
      if (error.eq.1) goto 910

      error = NF_INQ_VAR(cdfid,id,vnam,vartyp,ndim,vardim,nvatts)
      if (vartyp.ne.NF_FLOAT) error=1
      if (error.gt.0) then
        goto 920
      end if

      if (ndim.gt.MAXDIM) then
         error = 1
         go to 900
      endif

      do k=1,ndim 
        vardim(k)=dimsiz(vardim(k))
      enddo

      error = NF_GET_ATT_REAL(cdfid,id,'missing_value',misdat)
      if (error.gt.0) then
        goto 920     
      end if

      return

 900  write (6, *) '*ERROR*: When calling getcdf, the number of ',
     &             'variable dimensions must be less or equal 4.'
      error = NF_CLOSE (cdfid)
      return

 910  write (6, *) '*ERROR*: The selected variable could not be found ', 
     &             'in the file by getcdf.'
      error = NF_CLOSE (cdfid)
      return

 920  write (6, *) '*ERROR*: An error occurred while attempting to ',
     &             'read the data file in subroutine getcdf.'
      error = NF_CLOSE (cdfid)
      end

      FUNCTION STRBEG (string)

      integer strbeg
      character*(*) string
      integer i

      integer len

      do 10 i = 1, len(string)
         strbeg = i
         if (string(i:i).ne.' ' .and. string(i:i).ne.char(0)) then
            return
         endif
 10   continue
      strbeg = 0
      end


      FUNCTION STREND (string)
      integer strend
      character*(*) string
      integer i
      integer len

      do 10 i = len(string), 1, -1
         strend = i
         if (string(i:i) .ne. ' ' .and. string(i:i) .ne. char(0)) then
            return
         endif
 10   continue
      strend = 0
      end


      SUBROUTINE  HANDLE_ERR(status)
      include 'netcdf.inc'
      integer status
      if (status .ne. NF_NOERR)  then 
        print*, NF_STRERROR(status)
        stop 'STOPPED'
      end if
      end
